
###    TYPE  VICTIM
proc mc:cskill:increase {id victim type {apply 0}} {
    global mc mcs mck

    set id [mc:makeid $id]
    set victim [mc:makeid $victim]

    if { ![info exists mcs($id)] } { return }

    switch -- $type {
        a {
            if { $id == $victim } { return }
            if { $apply == 0 } {
                switch -- [mc:getstat prof $id] {
                    w { set apply 1.0 }
                    l { set apply 2.0 }
                    m { set apply 1.0 }
                    p { set apply 1.0 }
                }
            }
        }
        p {
            if { $id == $victim } { return }
            if { $apply == 0 } {
                switch -- [mc:getstat prof $id] {
                    w { set apply 2.0 }
                    l { set apply 1.0 }
                    m { set apply 1.0 }
                    p { set apply 1.0 }
                }
            }
        }
        default {
            return
        }
    }

    set maxcskill(a.w) 1000.0
    set maxcskill(a.l) 1000.0
    set maxcskill(a.m) 1000.0
    set maxcskill(a.p) 1000.0

    set maxcskill(p.w) 1000.0
    set maxcskill(p.l) 1000.0
    set maxcskill(p.m) 1000.0
    set maxcskill(p.p) 1000.0

    if { ![info exists mck($id)] } {
        set mck($id) ""
        set mck($id) [lappend mck($id) "$type $victim $apply"]
    } else {
        for { set i 0 } { $i < [llength $mck($id)] } { incr i } {
            set vict [lindex $mck($id) $i]

            if { [lindex $vict 0] == $type && [lindex $vict 1] == $victim } {
                if { [expr2 1 [lindex $vict 2] + $apply] > $maxcskill($type.[mc:getstat prof $id]) } {
                    set apply [expr2 1 $maxcskill($type.[mc:getstat prof $id]) - [lindex $vict 2]]
                }
                set vict [lreplace $vict 2 2 [expr2 1 [lindex $vict 2] + $apply]]
                set mck($id) [lreplace $mck($id) $i $i $vict]
                set mck($id) [lsort -ascii -index 0 $mck($id)]
                return
            }
        }
        set mck($id) [lappend mck($id) "$type $victim $apply"]
        set mck($id) [lsort -ascii -index 0 $mck($id)]
    }
}

###    TYPE  VICTIM  VALUE
proc mc:cskill:set {id victim type value} {
    global mc mcs mck

    set id [mc:makeid $id]
    set victim [mc:makeid $victim]

    if { ![info exists mcs($id)] } { return }

    if { ![info exists mck($id)] } {
        set mck($id) ""
        set mck($id) [lappend mck($id) "$type $victim $value"]
    } else {
        for { set i 0 } { $i < [llength $mck($id)] } { incr i } {
            set vict [lindex $mck($id) $i]

            if { [lindex $vict 0] == $type && [lindex $vict 1] == $victim } {
                set vict [lreplace $vict 2 2 $value]
                set mck($id) [lreplace $mck($id) $i $i $vict]
                set mck($id) [lsort -ascii -index 0 $mck($id)]
                return
            }
        }
        set mck($id) [lappend mck($id) "$type $victim $value"]
        set mck($id) [lsort -ascii -index 0 $mck($id)]
    }
}

###     TYPE  VICTIM
proc mc:cskill:get {id victim type} {
    global mc mcs mck

    set id [mc:makeid $id]
    set victim [mc:makeid $victim]

    if { ![info exists mcs($id)] } { return -1 }

    if { ![info exists mck($id)] } {
        return 0
    } else {
        foreach vict $mck($id) {
            if { [lindex $vict 0] != $type } { continue }
            if { [lindex $vict 1] == $victim } {
                return [lindex $vict 2]
            }
        }
    }
}

###       ID
proc mc:cskill:delete {id} {
    global mc mcs mck

    set id [mc:makeid $id]
    set victim [mc:makeid $victim]

    if { [info exists mck($id)] } {
        unset mck($id)
    }
}

###        VICTIM
proc mc:cskill:remove {victim {id ""} {type ""}} {
    global mc mcs mck

    set victim [mc:makeid $victim]
    if { $id != "" } { set id [mc:makeid $id] }

    if { $id != "" } {
        if { ![info exists mck($id)] } { return }

        for { set i 0 } { $i < [llength $mck($id)] } { incr i } {
            set vict [lindex $mck($id) $i]

            if { [lindex $vict 1] == $victim && ($type == "" || [lindex $vict 0] == $type) } {
                set vict [lreplace $vict 2 2 $value]
                set mck($id) [lreplace $mck($id) $i $i $vict]
                set mck($id) [lsort -ascii -index 0 $mck($id)]
            }
        }
    } else {
        foreach id [array names mck] {
            for { set i 0 } { $i < [llength $mck($id)] } { incr i } {
                set vict [lindex $mck($id) $i]

                if { [lindex $vict 1] == $victim } {
                    set vict [lreplace $vict 2 2 $value]
                    set mck($id) [lreplace $mck($id) $i $i $vict]
                    set mck($id) [lsort -ascii -index 0 $mck($id)]
                }
            }
        }
    }
}
