
### ###############################################################################
### # Filename: mc.magic.tcl                                                      #
### #                                                                             #
### # Description:                                                                #
### #      /                                      #
### ###############################################################################

proc mc:getpos {list targ} {
    set pos -1
    set i 0
    foreach char $list {
        if {[lindex $char 0] == $targ} {
            set pos $i
            break
        }
        incr i
    }

    return $pos
}

proc mc:appendcount {list targ} {
    set pos [mc:getpos $list $targ]

    if {$pos == -1} {
        set list [lappend list "$targ 1"]
    } else {
        set count [expr [lindex [lindex $list $pos] 1] + 1]
        set list [lreplace $list $pos $pos "$targ $count"]
    }

    return $list
}

proc mc:newshow {list pos targ time hits exp} {
    if {$pos == -1} {
        #  ,    
        set newshow "$targ {$time} $hits $exp"
        set list [lappend list $newshow]
    } else {
        #     ,   
        set newshow [lindex $list $pos]
        set showtime [lindex $newshow 1]
        set showtime [lsort -integer [lappend showtime $time]]
        set showhits [expr [lindex $newshow 2] + $hits]
        set showexp  [expr [lindex $newshow 3] + $exp]
        set newshow "$targ {$showtime} $showhits $showexp"
        set list [lreplace $list $pos $pos $newshow]
    }
    set ret ""
    set ret [lappend ret $newshow]
    set ret [lappend ret $list]
    return $ret
}

proc mc:getmaxcount {list targ} {
    set maxcount 0

    foreach char $list {
        if {[lindex $char 0] == $targ} {
            set maxcount [lindex $char 1]
            break
        }
    }

    return $maxcount
}

###       /
proc mc:operation:delete {iii {type "spell"}} {
    global mgtypei mgmanai mglevi mgprci mgtimei mghlongi mgstri mgid targi mgexp
    global sklid skltarg skltype skllev sklprc sklprice sklexp sklpass

    switch -- $type {
        "spell" {
            if { [info exists  mgtypei($iii)] } { unset mgtypei($iii)  }
            if { [info exists  mgmanai($iii)] } { unset mgmanai($iii)  }
            if { [info exists   mglevi($iii)] } { unset mglevi($iii)   }
            if { [info exists   mgprci($iii)] } { unset mgprci($iii)   }
            if { [info exists  mgtimei($iii)] } { unset mgtimei($iii)  }
            if { [info exists mghlongi($iii)] } { unset mghlongi($iii) }
            if { [info exists   mgstri($iii)] } { unset mgstri($iii)   }
            if { [info exists     mgid($iii)] } { unset mgid($iii)     }
            if { [info exists    targi($iii)] } { unset targi($iii)    }
            if { [info exists    mgexp($iii)] } { unset mgexp($iii)    }
        }
        "skill" {
            if { [info exists    sklid($iii)] } { unset sklid($iii)    }
            if { [info exists  skltarg($iii)] } { unset skltarg($iii)  }
            if { [info exists  skltype($iii)] } { unset skltype($iii)  }
            if { [info exists   skllev($iii)] } { unset skllev($iii)   }
            if { [info exists   sklprc($iii)] } { unset sklprc($iii)   }
            if { [info exists sklprice($iii)] } { unset sklprice($iii) }
            if { [info exists   sklexp($iii)] } { unset sklexp($iii)   }
            if { [info exists  sklpass($iii)] } { unset sklpass($iii)  }
        }
    }
}

###     /
proc mc:operation:getparam {num param {type "spell"}} {
    global mgtypei mgmanai mglevi mgprci mgtimei mghlongi mgstri mgid targi mgexp
    global sklid skltarg skltype skllev sklprc sklprice sklexp sklpass

    switch -- $type {
        "spell" {
            switch -- $param {
                "id"     { return $mgid($num) }
                "targ"   { return $targi($num) }
                "victim" { return $targi($num) }
                "type"   { return $mgtypei($num) }
                "level"  { return $mglevi($num) }
                "mana"   { return $mgmanai($num) }
                "price"  { return $mgmanai($num) }
                "prc"    { return $mgprci($num) }
                "time"   { return $mgtimei($num) }
                "long"   { return $mghlongi($num) }
                "str"    { return $mgstri($num) }
                "exp"    { return $mgexp($num) }
            }
        }
        "skill" {
            switch -- $param {
                "id"     { return $sklid($num) }
                "targ"   { return $skltarg($num) }
                "victim" { return $skltarg($num) }
                "type"   { return $skltype($num) }
                "level"  { return $skllev($num) }
                "mana"   { return $sklprice($num) }
                "price"  { return $sklprice($num) }
                "prc"    { return $sklprc($num) }
                "pass"   { return $sklpass($num) }
                "exp"    { return $sklexp($num) }
            }
        }
    }
}

###        
proc mc:magic:permanentfail {id mid} {
    global ctm mimmun nospellto

    set why ""
    if { [lsearch -exact $mimmun($id) $mid] != -1 }    { set why [lappend why $ctm(mfi)] }
    if { [lsearch -exact $nospellto($id) $mid] != -1 } { set why [lappend why $ctm(mff)] }
    if { $why != "" } { set why [format $ctm(mf) [join $why ", "] ] }

    return $why
}
