
if { ![mc:isbot public] } {
    listen $mc(dccport1) script mc:tel
    listen $mc(dccport2) script mc:ttel
}

###  
proc mc:tel {idx} {
    global mc mctn mctp mcnt

    control $idx mc:telnet
    set mctn($idx) ""
    set mctp($idx) ""
}

###   !dcc
proc mc:ttel {idx} {
    global mc mctn mctp mcnt nick

    control $idx mc:telnet
    set mctn($idx) ""
    set mctp($idx) ""
    putidx $idx "Nickname?\r"
}

proc mc:telnet {idx arg} {
    global mc mctn mctp mcs mcnt nick liv mcoptions

    if {[lindex [ms:fl $arg] 0] == "USER"} { return }
    if {$arg == ""} {
        putlog "TLN !$idx! closed !$mctn($idx)!"
        unset mctn($idx)
        unset mctp($idx)
        return
    }
    ###  
    if { $mctn($idx) == "" } {
        if {[lindex [ms:fl $arg] 0] == "100"} {
            ###     
            putidx $idx "101 $nick"
            set id [tolower [lindex [ms:fl $arg] 1]]
        } else {
            ###     !dcc
            set id [tolower [lindex [ms:fl $arg] 0]]
        }
        putlog "\(telnet\[$mctn($idx)/$idx\]\) TRY IDENT NICK: [lindex [ms:fl $arg] end]"
        if {[info exist mcs($id)]} {
            set mctn($idx) $id
            set mcnt($id) $idx
            putidx $idx "Password?\r"
            putlog "TLN: !$idx! - try password..."
        } else {
            putidx $idx "No such nick."
            putlog "TLN: !$idx! - bad nick !$arg!"
            killdcc $idx
            unset mctn($idx)
            unset mctp($idx)
        }
        return
    }
    ###  
    if { $mctp($idx) == "" } {
        set id $mctn($idx)
        if { [mc:getstat pass $id] == $arg } {
            ###  DCC    
            foreach tid [array names mctn] {
                if { $mctn($idx) == $mctn($tid) && $idx != $tid } {
                    putlog "TLN: !$idx!$id! - kill clone!$tid!"
                    putidx $tid "New DCC open.\r"
                    unset mcnt($mctn($tid))
                    unset mctn($tid)
                    unset mctp($tid)
                    killdcc $tid
                }
            }
            set mctn($idx) $id
            set mcnt($id) $idx
            set mctp($idx) $arg

            if { [mc:telnet:checkclone $idx] } {
                putlog "TLN: !$idx!$id! - host clones"
                putidx $idx "No allow more DCC-Chats from this host.\r"
                unset mctn($idx)
                unset mcnt($id)
                unset mctp($idx)
                killdcc $idx
                return
            }

            putidx $idx "You are logged.\r"
            putlog "TLN: !$idx!$id! - loged!"
            if { $mc(phase) >= 1 && [info exists liv($id)] } {
                mc:createlist
                set mcoptions(sendlist) 1
                foreach ls [mc:list] {
                    mc:msg $id $ls
                }
                set mcoptions(sendlist) 0
            }
        } else {
            putlog "TLN: !$idx!$id! - killed! pass - !$arg!"
            putidx $idx "Bad password.\r"
            unset mcnt($mctn($idx))
            unset mctn($idx)
            unset mctp($idx)
            killdcc $idx
        }
        return
    }
    foreach ee [binds "*mc:*"] {
        if {[string match -nocase [lindex $ee 2] [stripspec $arg]]} {
            if {[lindex $ee 0] == "msgm" && [lindex $ee 1] == "-|-"} {
                eval "[lindex $ee 4] {[stripspec [ms:dfl [ms:dfl $mctn($idx)]]]} {telnet@telnet} {nohandle} {[stripspec $arg]}"
            } else {
                putidx $idx "10     DCC."
            }
        }
    }
    putlog "\(telnet\[[ms:dfl [mc:getstat nick $mctn($idx)]]\]\) $arg"
}

proc mc:arenadcc {h i a} {
    global mc mctn mctp

    set addc "IDX\(%.3d\) %-20s - IDLE: %5dsec - %s \[%s, %s\]"

    foreach idx [dcclist] {
        if { [lindex $idx 1] == "*" && [lindex $idx 3] == "SCRIPT" && [lindex [lindex $idx 4] 1] == "mc:telnet" } {
            if { [info exists mctn([lindex $idx 0])] } {
                 set ids([lindex $idx 0]) "[string range [lindex $idx 2] [expr [string first "@" [lindex $idx 2]] + 1] end] [lindex $idx 5]"
            }
        }
    }

    putlog "Arena DCC-List:"
    foreach id [array names mctn] {
        set logged "04Not logged"
        if {$mctp($id) != ""} { set logged "Logged" }
        putlog "[format $addc $id [ms:dfl $mctn($id)] [getdccidle $id] $logged [lindex $ids($id) 0] [lindex $ids($id) 1]]"
    }
    putlog "End of DCC-List"
    putlog "Use .killadcc to kill \"04Not logged\" users."
}

proc mc:killarenadcc {h i a} {
    global mc mcnt mctn mctp

    putlog "Kill \"Not logged\" connections."
    foreach id [array names mctn] {
        if {$mctp($id) == ""} {
            unset mcnt($mctn($id))
            unset mctn($id)
            unset mctp($id)
            killdcc $id
        }
    }
}

proc mc:akill {h i a} {
    global mc mcnt mctn mctp

    set id [mc:makeid $a]
    putlog "Try to kill ADCC \"[ms:dfl $id]\""

    foreach tid [array names mctn] {
        if { [string match $id $mctn($tid)] } {
            putlog "ADCC [ms:dfl $mctn($tid)]($tid) killed."
            unset mctn($tid)
            unset mctp($tid)
            killdcc $tid
            if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $tid] != -1 } {
                set nn [lsearch -exact $mc(ident) $itid]
                set mc(ident) [lreplace $mc(ident) $nn $nn]
            }
        }
    }
}

proc mc:telnet:checkclone {idx} {
    global mc mcs mctn mctp mcnt mchost

    foreach idxx [dcclist] {
        if { [lindex $idxx 1] == "*" && [lindex $idxx 3] == "SCRIPT" && [lindex [lindex $idxx 4] 1] == "mc:telnet" } {
            if { [info exists mctn([lindex $idxx 0])] } {
                 set ids([lindex $idxx 0]) [string range [lindex $idxx 2] [expr [string first "@" [lindex $idxx 2]] + 1] end]
            }
        }
    }

    if { ![info exists ids($idx)] } { return }

    ### -=-=-=- <   > -=-=-=-
    set found 0
    set may 1
    set num 0
    if { [array exists mchost] } {
        foreach host [array names mchost] {
            set hh [string range [lindex $mchost($host) 0] [expr [string first "@" [lindex $mchost($host) 0]] + 1] end]

            if { [string match $hh $ids($idx)] } {
                set num $host
                break
            }
        }
    }
    if { $num != 0 } { set may [lindex $mchost($num) 1] }
    set mask $ids($idx)

    if { [array exists ids] } {
        foreach idxx [array names ids] {
            if { [string match $mask $ids($idxx)] } {
                incr found
            }
        }
    }

    if { $found > $may } {
        return 1
    }

    return 0
}
