
proc mc:gethark {id} {
    global mcs ct

    set tnl [mc:tnl $id]
    if { $tnl == -1 } {
        set tnl "!remort"
    } else {
        set tnl [expr $tnl - [mc:getstat exp $id]]
        if { $tnl <= 0 } {
            set tnl "level"
        }
    }

    if { [mc:getstat prof $id] == "w" || [mc:getstat prof $id] == "l" } {
        return [format $ct(3)  [mc:getstat exp $id] $tnl [mc:getmaxhp $id] [mc:getrmaxhp $id] [mc:getmaxmp $id] [mc:getrmaxmp $id] [mc:getstat gold $id] [mc:getstat bonus $id] [mc:getstat str $id] [mc:getstat rstr $id] [mc:getstat dex $id] [mc:getstat rdex $id] [mc:getstat wis $id] [mc:getstat rwis $id] [mc:getstat int $id] [mc:getstat rint $id] [mc:getstat con $id] [mc:getstat rcon $id] [mc:getstat free $id]]
    } else {
        return [format $ct(3m) [mc:getstat exp $id] $tnl [mc:getmaxhp $id] [mc:getrmaxhp $id] [mc:getmaxmp $id] [mc:getrmaxmp $id] [mc:getstat gold $id] [mc:getstat bonus $id] [mc:getstat str $id] [mc:getstat rstr $id] [mc:getstat dex $id] [mc:getstat rdex $id] [mc:getstat wis $id] [mc:getstat rwis $id] [mc:getstat int $id] [mc:getstat rint $id] [mc:getstat con $id] [mc:getstat rcon $id] [mc:getstat free $id]]
    }
}

proc mc:mrenick {n uh h t} {
    global mcs mco mcr mc ct cth

    if {![mc:ismaster $h]} { return }
    if {[llength $t] <= 2} {
        mc:msg $n "Format: !renick <oldnick> <newnick>"
        return
    }
    set id  [mc:makeid [lindex $t 1]]
    set id2 [mc:makeid [lindex $t 2]]
    if {$id == $id2} { return }
    if {[array exists mcr] && [info exists mcr($id)]} {
        mc:msg $n "         ."
        return
    }
    set onick [lindex $t 1]
    set nnick [lindex $t 2]
    set mcs($id2) $mcs($id)
    mc:setstat nick $id2 [lindex [ms:fl $t] 2]
    unset mcs($id)

    #      
    foreach cid [array names mco] {
        #putlog "cid = $cid"
        set access [mc:mcomget $cid 1]
        #putlog "  be access = $access"
        set found 0
        for {set j 0} {$j < [llength $access]} {incr j} {
            #putlog "  lindex = [lindex $access $j]"
            if {[lindex [lindex $access $j] 0] == $id && $found == 0} {
                set found 1
                set access [lreplace $access $j $j "$id2 [lindex [lindex $access $j] 1]"]
                #putlog "  st access = $access"
            } elseif {[lindex [lindex $access $j] 0] == $id && $found == 1} {
                set access [lreplace $access $j $j]
                incr j -1
                #putlog "  DELETE CLON. st access = $access"
            }
        }
        mc:mcomset $cid 1 $access
    }

    mc:msg $n "[xformat3 "%s &s1::::  %s." "[mc:getstat sex $id2]" $onick $nnick]"
}

proc mc:look {n uh h c t} {
    global mcs mc ct cth lastlook prof race thicoll

    if {[queuesize] > 10} { return }
    set id [mc:makeid $n]
    set id2 $id
    if {![mc:check $id -]} { return }
    set cost 0
    if {[llength $t] > 1} {
        if {[mc:getstat exp $id] < 100} { return }
        set id2 [mc:makeid [lindex $t 1]]
        if {![info exist mcs($id2)]} { return }
        set cost [expr [mc:getstat level $id] * 2]
        incr cost 10
    }
    if {[mc:getstat gold $id] < $cost} { return }

    if {[info exist lastlook] && $lastlook > [clock seconds]} { return }
    set lastlook [expr [clock seconds] + $mc(lastlook)]

    set output ""

    ### 
    if {$mc(sptitles) > 0 && [mc:getstat ptitle $id2] != "" && [mc:getstat remort $id2] >= [expr ($mc(sptitles) - 1) / 10] && [mc:getstat level $id2] >= [expr $mc(sptitles) % 10]} {
        set output "$output10[mc:getstat ptitle $id2]"
    }
    set output "$output12[mc:getstat nick $id2]"

    ### 
    if {$mc(stitles) > 0 && [mc:getstat title $id2] != "" && [mc:getstat remort $id2] >= [expr ($mc(stitles) - 1) / 10] && [mc:getstat level $id2] >= [expr $mc(stitles) % 10]} {
        set output "$output10[mc:getstat title $id2]"
    }
    set output "$output 14\("

    ###     regstr,   ,   
    if {[mc:getstat regstr $id2] != ""} {
        set output "[mc:getstat regstr $id2]14\("
    }

    ### /
    if {$mc(sraces) > 0 && [mc:getstat trace $id2] != "" && [mc:getstat remort $id2] >= [expr ($mc(sraces) - 1) / 10] && [mc:getstat level $id2] >= [expr $mc(sraces) % 10]} {
        set output "$output[mc:getstat trace $id2]"
    } else {
        set output "$output10[lindex $prof([mc:getstat prof $id2]) 0]14/10[lindex [lindex $race([mc:getstat race $id2]) 0] [mc:getstat sex $id2]]"
    }

    ###  
    set wer ""
    foreach weapon [mc:getstat wield $id2] {
        if {$weapon == "-"} {
            continue
        }
        set found 0
        foreach p [mc:getstat eq $id2] {
            if {[lindex $p 1] == $weapon && [lindex $p 2] != 0 && [lsearch -exact $wer $weapon] == -1} {
                set wer [lappend wer $weapon]
                set found 1
            }
        }
    }

    if {[mc:getstat remort $id2] == 0} {
        set output [format $ct(look) [ms:dfl $output] [mc:getstat level $id2] [mc:getstat exp $id2] [mc:getstat gold $id2] [mc:getstat game $id2] [mc:getstat win $id2] [mc:getstat death $id2] [mc:getstat run $id2]]
    } else {
        set output [format $ct(lookr) [ms:dfl $output] [mc:getstat remort $id2] [mc:getstat level $id2] [mc:getstat exp $id2] [mc:getstat gold $id2] [mc:getstat game $id2] [mc:getstat win $id2] [mc:getstat death $id2] [mc:getstat run $id2]]
    }

    if {[mc:getstat ltime $id2] > 0} {
        set output "$output [format $ct(lookt) [clock format [expr [mc:getstat ltime $id2] + $mc(timeshift)] -format "\[%d.%m.%Y %H:%M:%S\]"]]"
    }

    set out ""
    foreach weapon $wer {
        set out [lappend out [mc:wget $weapon name $id2]]
    }
    if {$out != ""} {
        set out [join $out ", "]
        set output "$output [format $ct(lookw) $out] "
    } else {
        set output "$output [format $ct(lookw) $ct(lookn)] "
    }

    ### 
    set string 1
    set thh ""
    set collections ""

    foreach tt [mc:getstat eq $id2] {
        if { $string == 1 } {
            if {[string length $thh] >= 100 || ([string length $output] >= 300 && [string length $thh] >= 1)} {
                incr string
                set thh [join $thh ", "]
                set output "$output[format $ct(looke) $thh]"
                mc:say $output
                set output ""
                set thh ""
            }
        } else {
            if { [string length $thh] >= 300 } {
                incr string
                set thh [join $thh ", "]
                set output "$output[format $ct(looke) $thh]"
                mc:say $output
                set output ""
                set thh ""
            }
        }

        if { [lindex $tt 2] == 1 } {
            if { [mc:wget [lindex $tt 1] weapon $id] > 0 && [lsearch -exact [mc:getstat wield $id] [lindex $tt 1]] == -1 } {
                continue
            }

            set newcol ""

            ###        ,       
            foreach col [array names thicoll] {
                if { [mc:incoll [lindex $tt 0] $col] && [mc:fullcoll $id2 $col] } {
                    if { [lsearch -exact $collections $col] == -1 } {
                        set collections [lappend collections $col]
                        set newcol $col
                    } else {
                        set newcol "-"
                    }
                    break
                }
            }

            if { $newcol != "-" && $newcol != "" } {
                set thh [lappend thh "<[mc:wgetcoll $newcol name]>" ]
            } elseif { $newcol != "-" && [lsearch -exact $wer [lindex $tt 1]] == -1 } {
                set thh [lappend thh [mc:wget [lindex $tt 1] name $id2] ]
            }

            if { [mc:wget [lindex $tt 1] name $id2] != [mc:wget [lindex $tt 0] name] && $newcol != "" && [lsearch -exact $wer [lindex $tt 1]] == -1 } {
                set thh [lappend thh [mc:wget [lindex $tt 1] name $id2] ]
            }
        }
    }

    if { $string > 1 } {
        if { $thh != "" } {
            set output ""
            set thh [join $thh ", "]
            set output "$output[format $ct(looke) $thh]"
            mc:say $output
        }
    } else {
        if { $thh == "" } {
            set thh $ct(lookn)
            set output "$output[format $ct(looke) $thh]"
            mc:say $output
        } else {
            set thh [join $thh ", "]
            set output "$output[format $ct(looke) $thh]"
            mc:say $output
        }
    }

    ###    ,      
    if { $cost > 0 } {
        mc:msg $n [format $ct(lookc) [ms:dfl [mc:getstat nick $id2]] $cost]
        mc:setstat gold $id [expr [mc:getstat gold $id] - $cost]
    }
}

proc mc:pass {n uh h t} {
    global mcs mc ct cth

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 1 } {
        mc:msg $n $cth(70)
        return
    }
    set pass [lindex [ms:fl $t] 0]

    ###      HAND  ,  
    if { [validuser $h] && [passwdok $h $pass] } {
        mc:msg $n "      ."
        return
    }

    if { [string length $pass] < 4 || [string length $pass] > 10 } {
        mc:msg $n $cth(71s)
        return
    }

    ###         ,  
    foreach litter [split [tolower $pass] ""] {
        if { [mc:checkin $litter "abcdefghijklmnopqrstuvwxyz0123456789"] == 0 } { 
            mc:msg $n $cth(71e)
            return
        }
    }

    mc:setstat pass $id $pass
    mc:msg $n [format $cth(71) [mc:getstat pass $id]]
    mc:logn $n "!PASS ..."
    if { ![info exist mc(ident)] } {
        set mc(ident) $id
    } elseif { [lsearch -exact $mc(ident) $id] == -1 } {
        set mc(ident) [lappend mc(ident) $id]
    }
}
proc mc:identify {n uh h t} {
    global mcs mc ct cth

    set id [mc:makeid $n]

    if { ![info exists mcs($id)] } { return }
    if { [llength $t] < 1 } {
        mc:msg $n $cth(72)
        return
    }

    if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $id] != -1 } {
        return
    }

    if { [mc:getstat pass $id] != [lindex [ms:fl $t] 0] } {
       # mc:msg $n $cth(73)
        mc:logn $n "!IDENT .... 04FALSE!"
    } else {
        mc:msg $n $cth(74)
        if { ![info exist mc(ident)] } {
            set mc(ident) $id
        } elseif { [lsearch -exact $mc(ident) $id] == -1 } {
            set mc(ident) [lappend mc(ident) $id]
        }
        mc:logn $n "!IDENT .... 03OK!"
    }
}

proc mc:mxstat {n uh h t} {
    global ct weaponweight thicoll

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    set atc 0.00
    set prt 0.00
    set heal 0.00

    set wer ""

    set sstr [mc:getstat str $id]
    set sdex [mc:getstat dex $id]
    set swis [mc:getstat wis $id]
    set sint [mc:getstat int $id]
    set scon [mc:getstat con $id]

    if { [mc:getstat prof $id] == "l" } {
        set atc [expr2 1 $atc + $sdex * 0.6 + $sint * 0.3]
    } else {
        set atc [expr2 1 $atc + $sdex * 0.6 + $sstr * 0.3]
    }
    set prt [expr2 1 $prt + $sdex * 0.4 + $scon * 0.6]

    ###        
    foreach thii [mc:getstat eq $id] {
        if { [lindex $thii 2] == 1 } {
            if { [lsearch -exact [mc:getstat wield $id] [lindex $thii 1]] != -1 } {
                set wer [lappend wer [lindex $thii 1]]
                set atc [expr2 1 $atc + [mc:wget [lindex $thii 1] atc $id]]
                set prt [expr2 1 $prt + [mc:wget [lindex $thii 1] prt $id]]
            } elseif { [mc:wget [lindex $thii 1] weapon $id] == 0 } {
                set atc [expr2 1 $atc + [mc:wget [lindex $thii 1] atc $id]]
                set prt [expr2 1 $prt + [mc:wget [lindex $thii 1] prt $id]]
            }
        }
    }

    ###     
    foreach col [array names thicoll] {
        if { ![mc:fullcoll $id $col] } { continue }
        set atc [expr2 1 $atc + [mc:wgetcoll $col atc]]
        set prt [expr2 1 $prt + [mc:wgetcoll $col prt]]
    }

    ###       
    set wmod 0
    if { [llength $wer] > 1 } {
        foreach weapon $wer {
            if { [mc:wget $weapon atcmod $id] > 0 } {
                set wmod [expr $wmod + [lindex $weaponweight([mc:wget $weapon atcmod $id]) 0]]
            }
        }
        set wmod [expr $wmod * 1.0 / [llength $wer]]
    }

    if { $wmod > 0 } {
        set atc [expr2 1 $atc / $wmod]
    }

    set mga 0.00
    set mgp 0.00

    if { [mc:getstat prof $id] == "m" } {
        set mga [expr2 1 $swis * 0.4 + $sint * 0.6]
        set mgp [expr2 1 $swis * 0.4 + $sint * 0.6]
    } elseif { [mc:getstat prof $id] == "p" } {
        set mga [expr2 1 $swis * 0.6 + $sint * 0.4]
        set mgp [expr2 1 $swis * 0.6 + $sint * 0.4]
    } elseif { [mc:getstat prof $id] == "l" } {
        set mga [expr2 1 ($swis + $sint) / 3.0]
        set mgp [expr2 1 ($swis + $sint) / 3.0]
    } elseif { [mc:getstat prof $id] == "w" } {
        set mga [expr2 1 ($swis + $sint) / 2.0]
        set mgp [expr2 1 ($swis + $sint) / 2.0]
    }

    set heal 0
    ###  
    if { [mc:getstat prof $id] == "m" } {
        set heal [expr2 2 $swis * 0.4 + $sint * 0.5]
    } elseif { [mc:getstat prof $id] == "p" } {
        set heal [expr2 2 $swis * 0.6 + $sint * 0.6]
    } elseif { [mc:getstat prof $id] == "l" } {
        set heal [expr2 2 $swis * 0.3 + $sint * 0.3]
    } elseif { [mc:getstat prof $id] == "w" } {
        set heal [expr2 2 $swis * 0.3 + $sint * 0.3]
    }
    set heal "[expr2 2 0.1 * $heal * 5 / 5]10x03[expr2 2 0.1 * $heal * 7 / 5]"

    ###  
    set mana [expr2 1 3.0 * (100 * ([mc:getstat wis $id] * 0.4) + 1.0 * ([mc:getstat int $id] * 0.6)) / 340]

    if { $wer != "" } {
        if { [mc:getstat prof $id] == "l" } {
            set hadd [expr2 2 $sint / (4.0 + [mc:getstat remort $id])]
        } elseif { [mc:getstat prof $id] == "w" } {
            set hadd [expr2 2 $sstr / (4.0 + [mc:getstat remort $id])]
        } else {
            set hadd [expr2 2 $sstr / 10.0]
        }

        set minhit 0.0
        set maxhit 0.0
        set healexist 0
        foreach weapon $wer {
            set hit [mc:wget $weapon hit $id]
            set hit [split $hit x]

            set minhit [expr2 2 $minhit + [lindex $hit 0]]
            set maxhit [expr2 2 $maxhit + [lindex $hit 1]]

            if { [mc:wget $wer heal $id] == 1 } {
                set healexist 1
                set color "12"
            } else {
                set color "03"
            }
        }
        if { $healexist == 0 } {
            set minhit [expr2 2 $minhit + $hadd]
            set maxhit [expr2 2 $maxhit + $hadd]
        }

        set hit "$color$minhit10x$color$maxhit"
    } else {
        set hit "03?"
    }
    if { [mc:getstat prof $id] == "l" } {
        set maxtarg [expr2 0 round(($swis * 0.7 + $sstr * 0.3) / 4.0)]
        if { $maxtarg < 1 } { set maxtarg 1 }
    }
    set lspell [expr $sint / (4 + [mc:getstat remort $id])]

    set out ""
    switch -- [mc:getstat prof $id] {
        w {
            set out [lappend out [format $ct(xstat.hit) $hit] ]
            set out [lappend out [format $ct(xstat.atc) $atc] ]
            set out [lappend out [format $ct(xstat.prt) $prt] ]
            set out [lappend out [format $ct(xstat.hp)  [mc:getmaxhp $id] [mc:getrmaxhp $id]] ]
            set out [lappend out [format $ct(xstat.ep)  [mc:getmaxmp $id] [mc:getrmaxmp $id]] ]
            set out [lappend out [format $ct(xstat.hl)  $heal] ]
            set out [lappend out [format $ct(xstat.en)  $mana] ]
            set out [lappend out [format $ct(xstat.mga) $mga] ]
            set out [lappend out [format $ct(xstat.mgp) $mgp] ]
        }
        l {
            set out [lappend out [format $ct(xstat.hit) $hit] ]
            set out [lappend out [format $ct(xstat.atc) $atc] ]
            set out [lappend out [format $ct(xstat.prt) $prt] ]
            set out [lappend out [format $ct(xstat.hp)  [mc:getmaxhp $id] [mc:getrmaxhp $id]] ]
            set out [lappend out [format $ct(xstat.ep)  [mc:getmaxmp $id] [mc:getrmaxmp $id]] ]
            set out [lappend out [format $ct(xstat.hl)  $heal] ]
            set out [lappend out [format $ct(xstat.en)  $mana] ]
            set out [lappend out [format $ct(xstat.mga) $mga] ]
            set out [lappend out [format $ct(xstat.mgp) $mgp] ]
            set out [lappend out [format $ct(xstat.mt)  $maxtarg] ]
        }
        m {
            set out [lappend out [format $ct(xstat.hit) $hit] ]
            set out [lappend out [format $ct(xstat.atc) $atc] ]
            set out [lappend out [format $ct(xstat.prt) $prt] ]
            set out [lappend out [format $ct(xstat.hp)  [mc:getmaxhp $id] [mc:getrmaxhp $id]] ]
            set out [lappend out [format $ct(xstat.mp)  [mc:getmaxmp $id] [mc:getrmaxmp $id]] ]
            set out [lappend out [format $ct(xstat.hl)  $heal] ]
            set out [lappend out [format $ct(xstat.mn)  $mana] ]
            set out [lappend out [format $ct(xstat.mga) $mga] ]
            set out [lappend out [format $ct(xstat.mgp) $mgp] ]
            set out [lappend out [format $ct(xstat.lsp) $lspell] ]
        }
        p {
            set out [lappend out [format $ct(xstat.hit) $hit] ]
            set out [lappend out [format $ct(xstat.atc) $atc] ]
            set out [lappend out [format $ct(xstat.prt) $prt] ]
            set out [lappend out [format $ct(xstat.hp)  [mc:getmaxhp $id] [mc:getrmaxhp $id]] ]
            set out [lappend out [format $ct(xstat.mp)  [mc:getmaxmp $id] [mc:getrmaxmp $id]] ]
            set out [lappend out [format $ct(xstat.hl)  $heal] ]
            set out [lappend out [format $ct(xstat.mn)  $mana] ]
            set out [lappend out [format $ct(xstat.mga) $mga] ]
            set out [lappend out [format $ct(xstat.mgp) $mgp] ]
            set out [lappend out [format $ct(xstat.lsp) $lspell] ]
        }
    }
    if { $out != "" } {
        set out [eval "format \$ct(xstat[mc:getstat prof $id]) $out"]
        set out "\{$out\}"

        ###   
        set tout ""
        set drainhit [mc:shop:calc $id drainhit]
        if { [lindex $drainhit 0] != "0.0x0.0" } {
            set tout [lappend tout [lindex $drainhit 0]]
            regsub -all "x" $tout "10x03" tout
        }
        if { [lindex $drainhit 1] != 0 } {
            set tout [lappend tout "[lindex $drainhit 1]%  "]
        }
        if { $tout != "" } {
            set tout [join $tout "10,03 "]
            set out [lappend out [format $ct(xstat.hd) $tout]]
        }

        ###   
        set tout ""
        set drainmana [mc:shop:calc $id drainmana]
        if { [lindex $drainmana 0] != "0.0x0.0" } {
            set tout [lappend tout [lindex $drainmana 0]]
            regsub -all "x" $tout "10x03" tout
        }
        if { [lindex $drainmana 1] != 0 } {
            set tout [lappend tout "[lindex $drainmana 1]%  "]
        }
        if { $tout != "" } {
            set tout [join $tout "10,03 "]
            set out [lappend out [format $ct(xstat.md) $tout]]
        }

        set out [join $out]
        mc:msg $n [format $ct(xstat) $out]
    }
}

proc mc:msex {n uh h t} {
    global mc mcs ct

    set id [mc:makeid $n]

    if {![mc:check $id -]} { return }

    if {[llength $t] == 1} {
        switch -- [mc:getstat sex $id] {
            0 { set asd "" }
            1 { set asd "" }
            2 { set asd "" }
        }
        mc:msg $n [format $ct(1a) $asd]
        return
    }
    set sex [join [lindex [split $t] 1]]
    switch -- $sex {
        m       { set asd "";     set asd2 0 }
        f       { set asd "";     set asd2 1 }
        default { set asd ""; set asd2 2}
    }
    mc:msg $n [format $ct(1a) $asd]
    mc:setstat sex $id $asd2
}

proc mc:reg {n uh h t} {
    global mcs mc ct cth prof race

    if { $mc(phase) != 0 } { return }

    set id [mc:makeid $n]

    if { [info exists mcs($id)] } {
        mc:msg $n $ct(1)
        return
    }

    if { $mc(nonewchar) == 1 } {
        mc:msg $n "   ."
        return
    }

    if { [string length $n] > $mc(maxnicklength) } {
        mc:msg $n "    ."
        return
    }

    if { [llength $t] != 3 } {
        mc:msg $n [xformat3 $cth(3) {} [mc:allrace] [mc:allprof]]
        return
    }
    if { [string first [lindex $t 1] [mc:allrace]] == -1 } {
        mc:msg $n [xformat3 $cth(4) "" [mc:allrace]]
        return
    }
    if { [string first [lindex $t 2] [mc:allprof]] == -1 } {
        mc:msg $n [xformat3 $cth(5) "" [mc:allprof]]
        return
    }

    set sstr [lindex $prof([lindex $t 2]) 1]
    set sdex [lindex $prof([lindex $t 2]) 2]
    set swis [lindex $prof([lindex $t 2]) 3]
    set sint [lindex $prof([lindex $t 2]) 4]
    set scon [lindex $prof([lindex $t 2]) 5]

    set sh [lindex $prof([lindex $t 2]) 6]
    set sg [lindex $prof([lindex $t 2]) 7]
    set sf [lindex $prof([lindex $t 2]) 13]
    set sk [lindex $prof([lindex $t 2]) 15]
    set mg [lindex $prof([lindex $t 2]) 16]

    incr sstr [lindex $race([lindex $t 1]) 1]
    incr sdex [lindex $race([lindex $t 1]) 2]
    incr swis [lindex $race([lindex $t 1]) 3]
    incr sint [lindex $race([lindex $t 1]) 4]
    incr scon [lindex $race([lindex $t 1]) 5]

    set outstr [expr [lindex $race([lindex $t 1]) 1] + [lindex $prof([lindex $t 2])  8] ]
    set outdex [expr [lindex $race([lindex $t 1]) 2] + [lindex $prof([lindex $t 2])  9] ]
    set outwis [expr [lindex $race([lindex $t 1]) 3] + [lindex $prof([lindex $t 2]) 10] ]
    set outint [expr [lindex $race([lindex $t 1]) 4] + [lindex $prof([lindex $t 2]) 11] ]
    set outcon [expr [lindex $race([lindex $t 1]) 5] + [lindex $prof([lindex $t 2]) 12] ]
    if { $outstr > 0 } { set outstr "+$outstr" }
    if { $outdex > 0 } { set outdex "+$outdex" }
    if { $outwis > 0 } { set outwis "+$outwis" }
    if { $outint > 0 } { set outint "+$outint" }
    if { $outcon > 0 } { set outcon "+$outcon" }
    set outbonus ""
    if { $outstr != 0 } { set outbonus [lappend outbonus "str/$outstr"] }
    if { $outdex != 0 } { set outbonus [lappend outbonus "dex/$outdex"] }
    if { $outwis != 0 } { set outbonus [lappend outbonus "wis/$outwis"] }
    if { $outint != 0 } { set outbonus [lappend outbonus "int/$outint"] }
    if { $outcon != 0 } { set outbonus [lappend outbonus "con/$outcon"] }
    set outbonus [join $outbonus ", "]

    set mcs($id) "{[ms:fl $n] -nopass- -} {[lindex $t 1] [lindex $t 2] 0 {} {} {} {}} {0 1 0 $sg 0 0 0 0 {}} {$sstr $sdex $swis $sint $scon $sf $sh} {{{waa 0 1 a {}}} {0 -} 0 {}} {0 {$mg} {$sk}} {0 0 0 [unixtime] 0 0 0}"

    if { [lindex $mc(test) 0] == 1 } {
        mc:setstat level  $id [lindex $mc(test) 1]
        mc:setstat remort $id [lindex $mc(test) 2]
        mc:setstat exp    $id [lindex $mc(test) 3]
        mc:setstat gold   $id [lindex $mc(test) 4]
        mc:setstat bonus  $id [lindex $mc(test) 5]
        mc:setstat str    $id [lindex $mc(test) 6]
        mc:setstat dex    $id [lindex $mc(test) 7]
        mc:setstat wis    $id [lindex $mc(test) 8]
        mc:setstat int    $id [lindex $mc(test) 9]
        mc:setstat con    $id [lindex $mc(test) 10]
        mc:setstat free   $id [lindex $mc(test) 11]
        mc:setstat favor  $id [lindex $mc(test) 12]
        mc:setstat magic  $id $mc(startmagic[lindex $t 2])
        mc:setstat skill  $id $mc(startskill[lindex $t 2])
        mc:setstat eq     $id $mc(startregeq[lindex $t 2])
    }

    mc:log "Create new char [ms:dfl [mc:getstat nick $id]]: ([mc:getstat race $id]/[mc:getstat prof $id]) ([lindex $prof([mc:getstat prof $id]) 0]/[lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]])"
    mc:msg $n "[format $ct(2) [lindex $prof([mc:getstat prof $id]) 0] [lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]] $outbonus][mc:gethark $id]"
    mc:msg $n "$ct(0a)"
}

proc mc:public:reg {n uh h t} {
    global mc ct cth prof race

    mc:msg $n "       04JuDeX10. [xformat3 $cth(3) {} [mc:allrace] [mc:allprof]]"
}

proc mc:drop {n uh h t} {
    global mc mcs mcr mcc mce ct

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [mc:getstat nodrop $id] == 1 } {
        mc:msg $n "     ."
        return
    }

    if { [mc:getstat remort $id] >= 1 } {
        mc:msg $n "   ,   !"
        return
    }

    if { $mc(phase) >= 1 && [info exists mcr($id)] } {
        mc:msg $n "  ()   ,      ."
        return
    }

    ###    
    if { $mc(phase) == 0 && [array exists mcr] && [info exists mcr($id)] } {
        mc:tsay $n [format $ct(14) [mc:delcom [ms:dfl $mcc($mcr($id))]]]
        putquick "MODE $mc(chan) -v $n"
        unset mcr($id)
        unset mce($id)
        if { [array size mcr] == 0 } {
            unset mcr
            unset mce
            unset mcc
        } else {
            foreach e [array names mcr] {
                set ttmm($mcr($e)) 1
            }
            foreach e [array names mcc] {
                if { ![info exists ttmm($e)] } {
                    unset mcc($e)
                }
            }
        }
    }

    ###  
    if { [mc:getstat exp $id] > 500 || [mc:getstat remort $id] > 0 } {
        set fid [open $mc(file.drop) a+]
        puts $fid $mcs($id)
        close $fid
    }

    mc:log "Drop char [ms:dfl [mc:getstat nick $id]]"
    mc:msg $n $ct(4)

#    mc:cskill:remove $id
#    mc:cskill:delete $id
    mc:delnickcom $id
    unset mcs($id)
    if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $id] != -1 } {
        set nn [lsearch -exact $mc(ident) $id]
        set mc(ident) [lreplace $mc(ident) $nn $nn]
    }
}

proc mc:com {n uh h t} {
    global mcs mc ct cth

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }


    if { [llength $t] > 1 } {
        set t [mc:delcom $t]
        mc:setstat com $id [lrange [ms:fl $t] 1 end]
    }
    mc:msg $n "$ct(9) 14< [ms:dfl [mc:getstat com $id]] 14>"
}

proc mc:hark {n uh h t} {
    global mcs mc ct cth hark harknum

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] == 1 } {
        mc:msg $n "$ct(6) [mc:gethark $id]"
        return
    }
    if { [llength $t] != 3 } {
        mc:msg $n $cth(1)
        return
    }

    if { [lindex $t 1] == "str" } {
        set hmod "rstr"
        set hmod2 "str"
    } elseif { [lindex $t 1] == "dex" } {
        set hmod "rdex"
        set hmod2 "dex"
    } elseif { [lindex $t 1] == "wis" } {
        set hmod "rwis"
        set hmod2 "wis"
    } elseif { [lindex $t 1] == "int" } {
        set hmod "rint"
        set hmod2 "int"
    } elseif { [lindex $t 1] == "con" } {
        set hmod "rcon"
        set hmod2 "con"
    } else {
        mc:msg $n $cth(1)
        return
    }
    set hnum [lindex $t 2]

    if { ![isnumber $hnum] } {
        mc:msg $n $cth(1)
        return
    }
    if { $hnum < 1 || [mc:getstat free $id] < $hnum } {
        mc:msg $n $ct(7)
        return
    }
    mc:logn $n "Add hark: $hmod2 +$hnum"
    mc:setstat free $id [expr [mc:getstat free $id] - $hnum]
    mc:setstat $hmod2 $id [expr [mc:getstat $hmod $id] + $hnum]
    mc:msg $n "[format $ct(8) $hark($hmod) $hnum] $ct(6) [mc:gethark $id]"
}

proc mc:msave {n uh h t} {
    mc:msg $n "  ."
    mc:save
}
proc mc:save {} {
    global mc mcs mco mck

    if { [mc:isbot public] } { return }
    if { $mc(savebase) != 1 } { return }

    putlog "Saving score file..."

    mc:nickexp
    mc:teamexp

    ###   
    putlog "  Saving players data..."
    set fid [open $mc(file.base) w]
    if { [array exists mcs] } {
        if { $mc(coding) == 1 } {
            foreach e [array names mcs] { puts $fid [mc:encrypt "$e $mcs($e)"] }
        } else {
            foreach e [array names mcs] { puts $fid "$e $mcs($e)" }
        }
    }
    close $fid

    ###   
    putlog "  Saving commands data..."
    set fid [open $mc(file.coms) w]
    if { [array exists mco] } {
        if { $mc(coding) == 1 } {
            foreach e [array names mco] { puts $fid [mc:encrypt "$e $mco($e)"] }
        } else {
            foreach e [array names mco] { puts $fid "$e $mco($e)" }
        }
    }
    close $fid

    ###    
#    putlog "  Saving combat-skills data..."
#    set fid [open $mc(file.skil) w]
#    if { [array exists mck] } {
#        if { $mc(coding) == 1 } {
#            foreach e [array names mck] { puts $fid [mc:encrypt "$e $mck($e)"] }
#        } else {
#            foreach e [array names mck] { puts $fid "$e $mck($e)" }
#        }
#    }
#    close $fid

    mc:confsave

    putlog "Saving score file complete."
}

proc mc:mread {n uh h t} {
    mc:msg $n "  ."
    mc:read
}
proc mc:read {} {
    global mc mcs mco mck

    if { [mc:isbot public] } { return }
    if { $mc(loadbase) != 1 } { return }

    putlog "Reading score file..."

    ###   
    putlog "  Reading players data..."
    if { [array exists mcs] } { unset mcs }
    if { [file exists $mc(file.base)] } {
        set fid [open $mc(file.base) r]
        while { ![eof $fid] } {
            gets $fid line
            if { $mc(coding) == 1 } {
                set line [mc:decrypt $line]
            }
            if { [llength $line] > 2 } {
                if { [string first "?" [lindex $line 0]] != -1 } {
                    set line [lreplace $line 0 0 [regsub -all "\[?\]" [lindex $line 0] ""]]
                }
                set mcs([lindex $line 0]) [lrange $line 1 end]
                #mc:checkmcs [lindex $line 0]
            }
        }
        close $fid
    }

    ###   
    putlog "  Reading commands data..."
    if { [array exists mco] } { unset mco }
    if { [file exists $mc(file.coms)] } {
        set fid [open $mc(file.coms) r]

        while { ![eof $fid] } {
            gets $fid line
            if { $mc(coding) == 1 } {
                set line [mc:decrypt $line]
            }
            if { [llength $line] > 2 } {
                if { [string first "?" [lindex $line 0]] != -1 } {
                    set line [lreplace $line 0 0 [regsub -all "\[?\]" [lindex $line 0] ""]]
                }
                set mco([lindex $line 0]) [lrange $line 1 end]
            }
        }
        close $fid
    }

    ###    
    putlog "  Reading combat-skills data..."
    if { [array exists mck] } { unset mck }
    if { [file exists $mc(file.skil)] } {
        set fid [open $mc(file.skil) r]

        while { ![eof $fid] } {
            gets $fid line
            if { $mc(coding) == 1 } {
                set line [mc:decrypt $line]
            }
            if { [llength $line] > 1 } {
                if { [string first "?" $line] != -1 } {
                    regsub -all "\[?\]" $line "" line
                }
                set mck([lindex $line 0]) [lrange $line 1 end]
            }
        }
        close $fid
    }

    mc:hostload
}

proc mc:checkmcs {id} {
    putlog "MC:checkmcs: $id"
    global mcs

    set temp [lindex $mcs($id) 0]
    while {[llength $temp] < 3} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 0 0 $temp]
    set temp [lindex $mcs($id) 1]
    while {[llength $temp] < 6} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 1 1 $temp]
    set temp [lindex $mcs($id) 2]
    while {[llength $temp] < 6} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 2 2 $temp]
    set temp [lindex $mcs($id) 3]
    while {[llength $temp] < 7} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 3 3 $temp]
    set temp [lindex $mcs($id) 4]
    while {[llength $temp] < 3} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 4 4 $temp]
    set temp [lindex $mcs($id) 5]
    while {[llength $temp] < 3} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 5 5 $temp]
    set temp [lindex $mcs($id) 6]
    while {[llength $temp] < 7} { set temp [lappend temp 0] }
    set mcs($id) [lreplace $mcs($id) 6 6 $temp]

    if {[mc:getstat remort $id] < 0}    { mc:setstat remort $id 0    }
    if {[mc:getstat remort $id] > 10}   { mc:setstat remort $id 10   }
    if {[mc:getstat level $id] < 1}     { mc:setstat level $id 1     }
    if {[mc:getstat level $id] > 15}    { mc:setstat level $id 15    }
    if {[mc:getstat exp $id] < 0}       { mc:setstat exp $id 0       }
    if {[mc:getstat exp $id] > 200000}  { mc:setstat exp $id 200000  }
    if {[mc:getstat gold $id] < 0}      { mc:setstat gold $id 0      }
    if {[mc:getstat gold $id] > 500000} { mc:setstat gold $id 500000 }
    if {[mc:getstat rstr $id] < 0}      { mc:setstat str $id 0       }
    if {[mc:getstat rstr $id] > 200}    { mc:setstat str $id 200     }
    if {[mc:getstat rdex $id] < 0}      { mc:setstat dex $id 0       }
    if {[mc:getstat rdex $id] > 200}    { mc:setstat dex $id 200     }
    if {[mc:getstat rwis $id] < 0}      { mc:setstat wis $id 0       }
    if {[mc:getstat rwis $id] > 200}    { mc:setstat wis $id 200     }
    if {[mc:getstat rint $id] < 0}      { mc:setstat int $id 0       }
    if {[mc:getstat rint $id] > 200}    { mc:setstat int $id 200     }
    if {[mc:getstat rcon $id] < 0}      { mc:setstat con $id 0       }
    if {[mc:getstat rcon $id] > 200}    { mc:setstat con $id 200     }
    if {[mc:getstat free $id] < 0}      { mc:setstat free $id 0      }
    if {[mc:getstat free $id] > 200}    { mc:setstat free $id 200    }
    if {[mc:getstat hbase $id] < 0}     { mc:setstat hbase $id 0     }
    if {[mc:getstat hbase $id] > 50}    { mc:setstat hbase $id 50    }
    if {[mc:getstat bonus $id] < 0}     { mc:setstat bonus $id 0     }
    if {[mc:getstat game $id] < 0}      { mc:setstat game $id 0      }
    if {[mc:getstat win $id] < 0}       { mc:setstat win $id 0       }
    if {[mc:getstat run $id] < 0}       { mc:setstat run $id 0       }
    if {[mc:getstat death $id] < 0}     { mc:setstat death $id 0     }
}

proc mc:mremort {n uh h t} {
    global mc mcs ct race prof thicoll records

    set id [mc:makeid $n]

    if {![mc:check $id 0]} { return }

    if {[mc:getstat level $id] < 10} {
        mc:msg $n $ct(remort1)
        return
    }

    mc:setstat remort $id [expr [mc:getstat remort $id] + 1]
    mc:setstat level $id 1
    mc:setstat exp $id 0
    mc:setstat eset $id 0

    mc:setstat str  $id [expr (5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 1]) + [lindex $race([mc:getstat race $id]) 1] + [lindex $prof([mc:getstat prof $id]) 1]]
    mc:setstat dex  $id [expr (5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 2]) + [lindex $race([mc:getstat race $id]) 2] + [lindex $prof([mc:getstat prof $id]) 2]]
    mc:setstat wis  $id [expr (5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 3]) + [lindex $race([mc:getstat race $id]) 3] + [lindex $prof([mc:getstat prof $id]) 3]]
    mc:setstat int  $id [expr (5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 4]) + [lindex $race([mc:getstat race $id]) 4] + [lindex $prof([mc:getstat prof $id]) 4]]
    mc:setstat con  $id [expr (5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 5]) + [lindex $race([mc:getstat race $id]) 5] + [lindex $prof([mc:getstat prof $id]) 5]]

    mc:setstat free $id [expr (1 * [mc:getstat remort $id]) + [lindex $prof([mc:getstat prof $id]) 13]]

    mc:setstat hbase $id [lindex $prof([mc:getstat prof $id]) 6]
    mc:setstat bonus $id 0
    mc:setstat skill $id [lindex $prof([mc:getstat prof $id]) 15]
    mc:setstat magic $id [lindex $prof([mc:getstat prof $id]) 16]

    ###    
    set profnum 0
    switch -- [mc:getstat prof $id] {
        l { set profnum 1 }
        m { set profnum 2 }
        p { set profnum 3 }
        w { set profnum 4 }
    }
    set records($profnum) [mc:recordremort $records($profnum) [mc:getstat remort $id] $id]
    mc:saverecords

    ###     
    set gold [mc:getstat gold $id]
    set neweq ""
    set changeeq 0
    putlog "Not delete stuff >= [expr 1000 * [mc:getstat remort $id]] price"
    foreach e [mc:getstat eq $id] {
        if { [lindex $e 0] == "waa" } { continue }
        set wremort 0
        if { [mc:wget [lindex $e 1] remort $id] != 0 } {
            set wremort 1
        } else {
            foreach coll [array names thicoll] {
                if { [mc:incoll [lindex $e 0] $coll] && [mc:fullcoll $id $coll] && [mc:wgetcoll $coll remort] != 0 } {
                    set wremort 1
                    break
                }
            }
        }
        if { $wremort != 0 || [mc:wget [lindex $e 1] price $id] >= [expr 1000 * [mc:getstat remort $id]] } {
            set e [lreplace $e 2 2 0]
            set e [lreplace $e 3 3 -]
            set neweq [lappend neweq $e]
        } else {
            set changeeq 1
            incr gold [mc:wget [lindex $e 1] price $id]
        }
    }

    ###   
    set newinv ""
    set changeinv 0
    foreach e [mc:getstat inv $id] {
        putlog "e == $e"
        if { $e == "{- -}" } { continue }
        ###      - 
        if { [mc:wgettal [lindex $e 0] remort] != 1 } {
            set newinv [lappend newinv $e]
        } else {
            set changeinv 1
        }
    }

    ###  50%    
    set gold [expr2 0 $gold * 0.50]

    if { $neweq != "" } {
        for {set i 0} {$i < [llength $neweq]} {incr i} {
            set neweq [lreplace $neweq $i $i [lreplace [lindex $neweq $i] 1 1 [expr $i + 1]]]
        }
    }
    set neweq "{waa 0 1 a {}} $neweq"
    mc:setstat eq $id "$neweq"
    mc:setstat wield $id "- -"

    #set newinv "{- -} $newinv"
    mc:setstat inv $id "$newinv"

    mc:setstat gold $id [expr2 0 $gold + [lindex $prof([mc:getstat prof $id]) 7]]

    mc:msg $n [format $ct(remort2) [expr 1 + [mc:getstat remort $id]]][mc:gethark $id]

    set new ""
    if { $changeeq  == 1 } { set new [lappend new $ct(remorte)] }
    if { $changeinv == 1 } { set new [lappend new $ct(remortt)] }
    if { $new != "" } {
        set new [join $new "  "]
        mc:msg $n [format $ct(remortn) $new]
    }
}

proc mc:noeq {n uh h t} {
    global mcs

    if { ![mc:ismaster $h] } { return }

    set ee [mc:makeid [lindex $t 1]]

    set neweq "{waa 0 1 a {}}"
    set gold [mc:getstat gold $ee]
    foreach ee2 [mc:getstat eq $ee] {
        if { [llength [lindex $ee2 4]] == 0 } {
            incr gold [mc:wget [lindex $ee2 0] price]
        } else {
            set neweq [lappend neweq $ee2]
        }
    }
    if { [llength $neweq] == 1 } {
        set neweq "{$neweq}"
    }
    mc:setstat gold $ee $gold
    mc:setstat eq $ee $neweq
    mc:setstat wield $ee "- -"
}

proc mc:putoffall {n uh h t} {
    global mcs prof race

    if {![mc:ismaster $h]} { return }

    if {[llength $t] < 5} {
        mc:msg $n "Format: !putoffall <races> <profs> <minlevel> <minremort>"
        return
    }
    set races [mc:allrace]
    if { [lindex $t 1] != "-" } { set races [lindex $t 1] }
    set profs [mc:allprof]
    if { [lindex $t 2] != "-" } { set profs [lindex $t 2] }
    set minlevel 1
    if { [lindex $t 3] != "-" } { set minlevel [lindex $t 3] }
    set minremort 0
    if { [lindex $t 4] != "-" } { set minremort [lindex $t 4] }

    putlog "PUTOFF ALL by $n... Races: $races, Profs: $profs, MinLevel: $minlevel, MinRemort: $minremort"

    foreach ee [array names mcs] {
        if { ![mc:checkin [mc:getstat race $ee] $races] } { continue }
        if { ![mc:checkin [mc:getstat prof $ee] $profs] } { continue }
        if { [mc:getstat level $ee]  < $minlevel }  { continue }
        if { [mc:getstat remort $ee] < $minremort } { continue }

        set neweq ""
        foreach item [mc:getstat eq $ee] {
            set item [lreplace $item 2 2 0]
            set item [lreplace $item 3 3 -]
            set neweq [lappend neweq $item]
        }
        mc:setstat eq $ee "$neweq"
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:nostat {n uh h t} {
    global mcs prof race

    if { ![mc:ismaster $h] } { return }

    set ee [mc:makeid [lindex $t 1]]
    set lev [mc:getstat level $ee]
    mc:setstat str  $ee [expr [lindex $prof([mc:getstat prof $ee]) 1] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 1]) + [lindex $race([mc:getstat race $ee]) 1] * $lev + [lindex $prof([mc:getstat prof $ee]) 8]  * ($lev - 1)]
    mc:setstat dex  $ee [expr [lindex $prof([mc:getstat prof $ee]) 2] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 2]) + [lindex $race([mc:getstat race $ee]) 2] * $lev + [lindex $prof([mc:getstat prof $ee]) 9]  * ($lev - 1)]
    mc:setstat wis  $ee [expr [lindex $prof([mc:getstat prof $ee]) 3] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 3]) + [lindex $race([mc:getstat race $ee]) 3] * $lev + [lindex $prof([mc:getstat prof $ee]) 10] * ($lev - 1)]
    mc:setstat int  $ee [expr [lindex $prof([mc:getstat prof $ee]) 4] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 4]) + [lindex $race([mc:getstat race $ee]) 4] * $lev + [lindex $prof([mc:getstat prof $ee]) 11] * ($lev - 1)]
    mc:setstat con  $ee [expr [lindex $prof([mc:getstat prof $ee]) 5] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 5]) + [lindex $race([mc:getstat race $ee]) 5] * $lev + [lindex $prof([mc:getstat prof $ee]) 12] * ($lev - 1)]
    mc:setstat free $ee [expr ([lindex $prof([mc:getstat prof $ee]) 13] + 1 * [mc:getstat remort $ee]) * $lev]

    set neweq ""
    foreach item [mc:getstat eq $ee] {
        set item [lreplace $item 2 2 0]
        set item [lreplace $item 3 3 -]
        set neweq [lappend neweq $item]
    }
    mc:setstat eq $ee "$neweq"
    mc:setstat eset $ee 0

    mc:log "Reset STATS for [mc:getstat nick $ee] - done"
    mc:msg $n "reset STATS for [mc:getstat nick $ee] - done"
}

proc mc:updatestat {n uh h t} {
    global mc mcs mco prof race

    if { ![mc:ismaster $h] } { return }

    if { [llength $t] < 5 } {
        mc:msg $n "Format: !updatestats <races> <profs> <minlevel> <minremort>"
        return
    }
    set races [mc:allrace]
    if { [lindex $t 1] != "-" } { set races [lindex $t 1] }
    set profs [mc:allprof]
    if { [lindex $t 2] != "-" } { set profs [lindex $t 2] }
    set minlevel 1
    if { [lindex $t 3] != "-" } { set minlevel [lindex $t 3] }
    set minremort 0
    if { [lindex $t 4] != "-" } { set minremort [lindex $t 4] }

    putlog "Update STATS by $n... Races: $races, Profs: $profs, MinLevel: $minlevel, MinRemort: $minremort"

    foreach ee [array names mcs] {
        set lev [mc:getstat level $ee]

        if { ![mc:checkin [mc:getstat race $ee] $races] } { continue }
        if { ![mc:checkin [mc:getstat prof $ee] $profs] } { continue }
        if { [mc:getstat level $ee]  < $minlevel }  { continue }
        if { [mc:getstat remort $ee] < $minremort } { continue }

        mc:setstat str  $ee [expr [lindex $prof([mc:getstat prof $ee]) 1] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 1]) + [lindex $race([mc:getstat race $ee]) 1] * $lev + [lindex $prof([mc:getstat prof $ee]) 8]  * ($lev - 1)]
        mc:setstat dex  $ee [expr [lindex $prof([mc:getstat prof $ee]) 2] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 2]) + [lindex $race([mc:getstat race $ee]) 2] * $lev + [lindex $prof([mc:getstat prof $ee]) 9]  * ($lev - 1)]
        mc:setstat wis  $ee [expr [lindex $prof([mc:getstat prof $ee]) 3] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 3]) + [lindex $race([mc:getstat race $ee]) 3] * $lev + [lindex $prof([mc:getstat prof $ee]) 10] * ($lev - 1)]
        mc:setstat int  $ee [expr [lindex $prof([mc:getstat prof $ee]) 4] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 4]) + [lindex $race([mc:getstat race $ee]) 4] * $lev + [lindex $prof([mc:getstat prof $ee]) 11] * ($lev - 1)]
        mc:setstat con  $ee [expr [lindex $prof([mc:getstat prof $ee]) 5] + (5 * [mc:getstat remort $ee] * [lindex $race([mc:getstat race $ee]) 5]) + [lindex $race([mc:getstat race $ee]) 5] * $lev + [lindex $prof([mc:getstat prof $ee]) 12] * ($lev - 1)]

        mc:setstat free $ee [expr ([lindex $prof([mc:getstat prof $ee]) 13] + 1 * [mc:getstat remort $ee]) * $lev]
        set neweq ""
        foreach item [mc:getstat eq $ee] {
            set item [lreplace $item 2 2 0]
            set item [lreplace $item 3 3 -]
            set neweq [lappend neweq $item]
        }
        mc:setstat eq $ee "$neweq"
        mc:setstat eset $ee 0
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:updateeq {n uh h t} {
    global mc mcs mco prof race

    if { ![mc:ismaster $h] } { return }

    if { [llength $t] < 5 } {
        mc:msg $n "Format: !updateeq <races> <profs> <minlevel> <minremort>"
        return
    }
    set races [mc:allrace]
    if { [lindex $t 1] != "-" } { set races [lindex $t 1] }
    set profs [mc:allprof]
    if { [lindex $t 2] != "-" } { set profs [lindex $t 2] }
    set minlevel 1
    if { [lindex $t 3] != "-" } { set minlevel [lindex $t 3] }
    set minremort 0
    if { [lindex $t 4] != "-" } { set minremort [lindex $t 4] }

    putlog "Update EQ by $n... Races: $races, Profs: $profs, MinLevel: $minlevel, MinRemort: $minremort"

    foreach ee [array names mcs] {
        if { ![mc:checkin [mc:getstat race $ee] $races] } { continue }
        if { ![mc:checkin [mc:getstat prof $ee] $profs] } { continue }
        if { [mc:getstat level $ee]  < $minlevel }  { continue }
        if { [mc:getstat remort $ee] < $minremort } { continue }

        set gold [mc:getstat gold $ee]
        set neweq "{waa 0 1 a {}}"
        foreach ee2 [mc:getstat eq $ee] {
            if { [llength [lindex $ee2 4]] == 0 } {
                incr gold [mc:wget [lindex $ee2 0] price]
            } else {
                set neweq [lappend neweq $ee2]
            }
        }
        if { [llength $neweq] == 1 } {
            set neweq "{$neweq}"
        }
        mc:setstat gold $ee $gold
        mc:setstat eq $ee $neweq
        mc:setstat wield $ee "- -"
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:updateskl {n uh h t} {
    global mc mcs mco prof race skill _skill skillo _skillo

    if { ![mc:ismaster $h] } { return }

    putlog "Update SK by $n... [lindex $t 1]"

    foreach ee [array names mcs] {
        set bonus 0
        if { [llength $t] > 1 && [lindex $t 1] == "b" } {
            foreach sk [mc:getstat skill $ee] {
                if { [lindex $sk 0] != "-" } { incr bonus [lindex $sk 1] }
            }
        }
        mc:setstat skill $ee [lindex $prof([mc:getstat prof $ee]) 15]
        mc:setstat bonus $ee [expr [mc:getstat bonus $ee] + $bonus]
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:updatemag {n uh h t} {
    global mc mcs mco prof race

    if { ![mc:ismaster $h] } { return }

    if { [llength $t] < 5 } {
        mc:msg $n "Format: !updatemag <races> <profs> <minlevel> <minremort>"
        return
    }
    set races [mc:allrace]
    if { [lindex $t 1] != "-" } { set races [lindex $t 1] }
    set profs [mc:allprof]
    if { [lindex $t 2] != "-" } { set profs [lindex $t 2] }
    set minlevel 1
    if { [lindex $t 3] != "-" } { set minlevel [lindex $t 3] }
    set minremort 0
    if { [lindex $t 4] != "-" } { set minremort [lindex $t 4] }

    putlog "Update MG by $n... Races: $races, Profs: $profs, MinLevel: $minlevel, MinRemort: $minremort"

    foreach ee [array names mcs] {
        if { ![mc:checkin [mc:getstat race $ee] $races] } { continue }
        if { ![mc:checkin [mc:getstat prof $ee] $profs] } { continue }
        if { [mc:getstat level $ee]  < $minlevel }  { continue }
        if { [mc:getstat remort $ee] < $minremort } { continue }

        mc:setstat magic $ee [lindex $prof([mc:getstat prof $ee]) 16]
    }
    mc:msg $n "  ."
    putlog "Done."
}

proc mc:wipe {n uh h t} {
    global mc mcs mco mctn mctp

    set id [mc:makeid [lindex $t 1]]
    #if {![mc:check $id 0]} { return }

    if { [array size mcs] <= 1 } {
        mc:msg $n "   ."
        return
    }

    set fid [open $mc(file.base).wipe a+]
    puts $fid "---------- [clock format [clock seconds] -format "\[%d.%m.%Y %H:%M:%S\]"]"
    if {[array exists mcs]} { foreach e [array names mcs] { puts $fid "$e $mcs($e)" } }
    close $fid

    set fid [open $mc(file.coms).wipe a+]
    puts $fid "---------- [clock format [clock seconds] -format "\[%d.%m.%Y %H:%M:%S\]"]"
    if {[array exists mco]} { foreach e [array names mco] { puts $fid "$e $mco($e)" } }
    close $fid

#    file delete $mc(file.base).backup
#    file delete $mc(file.coms).backup

    if { [info exist mcs] } { unset mcs }
    if { [info exist mco] } { unset mco }
    foreach idx [array names mctn] {
        killdcc $idx
        unset mctn($idx)
        unset mctp($idx)
    }
    if {[info exist mc(ident)]} { unset mc(ident) }

    putlog "WIPE BASE by $n"
    set stri "04$n   "
    if { [llength $t] > 1 } { set stri "$stri: 10\"[lrange $t 1 end]\"04" }
    set stri "$stri."
    mc:say "$stri"
    mc:save
}

proc mc:dropchar {n uh h t} {
    global mc mcs mcr mcc mce ct

    if {[llength $t] < 2} {
        mc:msg $n "Format: !dropchar <name>"
        return
    }
    set id [mc:makeid [lindex $t 1]]
    #if {![mc:check $id -]} { return }

    if {![array exists mcs] || ![info exist mcs($id)]} {
        mc:msg $n " [lindex $t 1]  ."
        return
    } else {
        if {[array exists mcr] && [info exists mcr($id)]} {
            mc:tsay $n [format $ct(14) [mc:delcom [ms:dfl $mcc($mcr($id))]]]
            pushmode $mc(chan) -v $n
            unset mcr($id)
            unset mce($id)
            if {[array size mcr] == 0} {
                unset mcr
                unset mce
                unset mcc
            } else {
                foreach e [array names mcr] {
                    set ttmm($mcr($e)) 1
                }
                foreach e [array names mcc] {
                    if {![info exists ttmm($e)]} {
                        unset mcc($e)
                    }
                }
            }
        }

        if {[mc:getstat exp $id] > 500 || [mc:getstat remort $id] > 0} {
            set fid [open $mc(file.drop) a+]
            puts $fid $mcs($id)
            close $fid
        }
#        mc:cskill:remove $id
#        mc:cskill:delete $id
        mc:delnickcom $id
        unset mcs($id)
        if { [info exist mc(ident)] && [lsearch -exact $mc(ident) $id] != -1 } {
            set nn [lsearch -exact $mc(ident) $id]
            set mc(ident) [lreplace $mc(ident) $nn $nn]
        }
        putlog "DROP [lindex $t 1] by $n"
        mc:msg $n " 04[lindex $t 1]10 ."
    }
}

proc mc:copychar {n uh h t} {
    global mc mcs ct

    if {[llength $t] < 3} {
        mc:msg $n "Format: !copychar <ID> <string>"
        return
    }

    set id [mc:makeid [lindex $t 1]]
    set string [lrange $t 2 end]

    set mcs($id) $string
    mc:msg $n "Char($id) copied."
}

proc mc:mtransfer {n uh h t} {
    global mc mcs ct cth

    set id [mc:makeid $n]

    if {[llength $t] < 2} {
        mc:msg $n $ct(tranf)
        return
    }
    switch -- [tolower [lindex $t 1]] {
        "bonus" {
            set count [expr round([mc:getstat bonus $id]) / 10]
            set ost   [expr round([mc:getstat bonus $id]) % 10]
            if {$count == 0} {
                mc:msg $n $ct(tranbn)
                return
            }
            switch -- [mc:getstat prof $id] {
                m       { set val [mc:getstat rint $id]                                }
                l       { set val [expr [mc:getstat rwis $id] + [mc:getstat rint $id]] }
                p       { set val [mc:getstat rwis $id]                                }
                w       { set val [expr [mc:getstat rwis $id] + [mc:getstat rint $id]] }
                default { set val [expr [mc:getstat rwis $id] + [mc:getstat rint $id]] }
            }
            mc:setstat gold $id [expr [mc:getstat gold $id] + $count * $val]
            mc:setstat bonus $id $ost
            mc:msg $n [format $ct(tranbo) [expr $count * $val] [expr $count * 10]]
            mc:msg $n [format $cth(34) [mc:getstat bonus $id]]
        }
        default { mc:msg $n $ct(tranf) }
    }    
}

#    
proc mc:readrecords {} {
    global mc mcs records

    putlog "Reading records..."

    if { [array exists records] } { unset records }

    ### : l m p w "nick"
    set records(1)  "{{- -} {- -} {- -} {- -} {- -}}"
    set records(2)  "{{- -} {- -} {- -} {- -} {- -}}"
    set records(3)  "{{- -} {- -} {- -} {- -} {- -}}"
    set records(4)  "{{- -} {- -} {- -} {- -} {- -}}"
    ### .  "value nick"
    set records(5)  "- -"
    ### .   "value nick"
    set records(6)  "- -"
    ### .   "value nick"
    set records(7)  "- -"
    ### .     "value nick"
    set records(8)  "- -"
    ### .   "value nick"
    set records(9)  "- -"
    ### .   "value nick magic"
    set records(10) "- - -"
    ### .     "value nick"
    set records(11) "- -"

    if { [file exists $mc(file.recs)] } {
        set fid [open $mc(file.recs) r]
        set i 1
        while { ![eof $fid] } {
            gets $fid l
            set records($i) $l
            incr i
        }
        close $fid
        unset records([expr $i - 1])
    }
}

###    
proc mc:saverecords {} {
    global mc mcs records

    putlog "Saving records..."
    set fid [open $mc(file.recs) w]

    if { [array exists records] } {
        for {set i 1} {$i <= [array size records]} {incr i} {
            puts $fid "$records($i)"
        }
    }
    close $fid
}

proc mc:ptop {n uh h c t} {
    global mcs mc ct cth lasttop prof topnicks

    set id [mc:makeid $n]

    if { $mc(topsize) == 0 } { return }
    if { $mc(phase) != 0 } { return }
    if { [info exist lasttop] && ($lasttop > [clock seconds]) } { return }
    set lasttop [expr [clock seconds] + $mc(lasttop)]
    if { [queuesize] > 10 } { return }
    if { ![info exist mcs($id)] } { return }

    set order "w l m p"

    foreach prf $order {
        if { $topnicks($prf) == "" } { continue }

        set out ""
        set size 0
        foreach e $topnicks($prf) {
            set out [lappend out [format $ct(tope) [ms:dfl [mc:getstat nick $e]] [mc:getstat exp $e]]]
            incr size
        }

        set place "$size-"
        set suf1 ""
        set suf2 ""
        if { $size == 1 } {
            set place $size
            switch -- [mc:getstat sex $topnicks($prf)] {
                0 { set place ""; set suf1 "" }
                1 { set place ""; set suf1 "" }
                2 { set place ""; set suf1 "" }
            }
            set suf2 ""
        }

        set string "[lindex $prof($prf) 0]$suf2"
        set out [join $out ", "]
        mc:say [format $ct(top) $place $suf1 $suf1 $string $out]
    }
}

###        
proc mc:tnl {id} {
    if { [mc:getstat level $id] < 1 || [mc:getstat level $id] >= 10 } { return -1 }

    set clevel 2
    set ex 2
    set exp 2000
    set factor 2.0
    set rfactor [expr 1.00 + [mc:getstat remort $id] * 0.10]

    while {$clevel <= [mc:getstat level $id]} {
        set ex  [expr round($ex * $factor)]
        set exp [expr round($ex * $rfactor) * 1000]
        set factor [expr $factor - 0.1]
        incr clevel
    }

    set exp [expr round(round($ex) * $rfactor) * 1000]

    return $exp
}

###      
proc mc:gainlevel {id} {
    global mc mcs prof race

    mc:setstat level $id [expr [mc:getstat level $id] + 1]
    mc:logn [ms:dfl [mc:getstat nick $id]] "Get new level: [mc:getstat level $id]"

    mc:setstat str  $id [expr [mc:getstat rstr $id] + [lindex $race([mc:getstat race $id]) 1]  + [lindex $prof([mc:getstat prof $id]) 8]]
    mc:setstat dex  $id [expr [mc:getstat rdex $id] + [lindex $race([mc:getstat race $id]) 2]  + [lindex $prof([mc:getstat prof $id]) 9]]
    mc:setstat wis  $id [expr [mc:getstat rwis $id] + [lindex $race([mc:getstat race $id]) 3]  + [lindex $prof([mc:getstat prof $id]) 10]]
    mc:setstat int  $id [expr [mc:getstat rint $id] + [lindex $race([mc:getstat race $id]) 4]  + [lindex $prof([mc:getstat prof $id]) 11]]
    mc:setstat con  $id [expr [mc:getstat rcon $id] + [lindex $race([mc:getstat race $id]) 5]  + [lindex $prof([mc:getstat prof $id]) 12]]
    mc:setstat free $id [expr [mc:getstat free $id] + [lindex $prof([mc:getstat prof $id]) 13] + (1 * [mc:getstat remort $id])]
}
